/*
 *	Ged, Freya alternate shell Ver0.81
 *	issued: 2000/4/2
 *	author: c.mos@zob.ne.jp
 */

#include "ged.h"
#include "ilib.h"
#include "menu.h"
#include "dialog.h"
#include "folder.h"
#include "icons.h"
#include "prof.h"
#include "remote.h"
#include "../debug.h"

enum {
	MENU_SYS, MENU_FILE, MENU_GROUP, MENU_VIEW, MENU_TOOL, POPUP_MENU_COUNT
};

#define SYS_MENU_COUNT 3

MenuItem items_sys[SYS_MENU_COUNT] = {
	"Reboot", "u[g", 0, ID_SYS_REBOOT,
	NULL, NULL, 0, 0,
	"Version", "VXẽo[W", 0, ID_SYS_VERSION,
};

#define FILE_MENU_COUNT 8
	
MenuItem items_file[FILE_MENU_COUNT] = {
	"Remote", "[g[h", 0, ID_FILE_REMOTE,
	NULL, NULL, 0, 0,
	"Load", "t@CM", 0, ID_FILE_LOAD,
	"Save", "t@C𑗐M", 0, ID_FILE_SAVE,
	NULL, NULL, 0, 0,
	"Delete", "t@C폜", 0, ID_FILE_DELETE,
	NULL, NULL, 0, 0,
	"Info", "t@C̏\\", 0, ID_FILE_INFO,
};


#define GROUP_MENU_COUNT 4

MenuItem items_group[GROUP_MENU_COUNT] = {
	"Flash", "Flash ROM̃t@C\\", MF_RADIOCHECK, ID_GROUP_FLASH,
	"SRAM", "SRAM̃t@C\\", 0, ID_GROUP_SRAM,
	NULL, NULL, 0, 0,
	"System", "VXet@C\\", 0, ID_GROUP_SYSTEM
};

#define VIEW_MENU_COUNT 4

MenuItem items_view[VIEW_MENU_COUNT] = {
	"Icon", "ACRŕ\\", MF_RADIOCHECK, ID_VIEW_ICON,
	"List", "Xgŕ\\", 0, ID_VIEW_LIST,
	NULL, NULL, 0, 0,
	"Tile", "ǎ\\", MF_CHECKED, ID_VIEW_WALLPAPER,
};

#define TOOL_MENU_COUNT 6

MenuItem items_tool[TOOL_MENU_COUNT] = {
	"Deflag", "̃tH_𐮗", 0, ID_TOOL_DEFLAG,
	"Erase All", "̃tH_", 0, ID_TOOL_ERASE,
	NULL, NULL, 0, 0,
/*	"Mem Dump", "[_v", 0, ID_TOOL_DUMP,*/
	"Char Map", "R[h\\", 0, ID_TOOL_CHARMAP,
	NULL, NULL, 0, 0,
	"Trace", "[gfobO[h(vfrdeb)", MF_GRAYED, ID_TOOL_TRACE,
};

Menu menus[POPUP_MENU_COUNT] = {
	{ items_sys,  SYS_MENU_COUNT , 0, 0,0,0,0 },
	{ items_file, FILE_MENU_COUNT, 0, 0,0,0,0 },
	{ items_group, GROUP_MENU_COUNT, 0, 0,0,0,0 },
	{ items_view, VIEW_MENU_COUNT, 0, 0,0,0,0 },
	{ items_tool, TOOL_MENU_COUNT, 0, 0,0,0,0 },
};

MenuItem items_bar[POPUP_MENU_COUNT] = {
	"\002", NULL, 0, 0,
	"File", NULL, 0, 0,
	"Group", NULL, 0, 0,
	"View", NULL, 0, 0,
	"Tools",NULL, 0, 0,
};

MenuBar menu_bar = { items_bar, POPUP_MENU_COUNT, 1, menus };

#define MAX_APPLINK 16

typedef struct {
	char name[MAXFNAME+1];
	char app[MAXFNAME+1];
} AppLink;

AppLink applink[MAX_APPLINK];
int applink_count = 0;

#define MAX_SHORTKEY 5

typedef struct {
	char *name;
	WORD key;
	int  command;
} ShortKey;

ShortKey shortkey[MAX_SHORTKEY] = { "START", 0x002, 0, "Y1", 0x100, 0, "Y2", 0x200, 0, "Y3", 0x400, 0, "Y4", 0x800, 0 };

Folder folder;
char *fs_name[FS_COUNT] = { "FLASH", "SRAM" };

char msgbuff[MESSAGE_MAX];
Options options = { 1 };

void init_display(BOOL cls);
void draw_wallpaper(void);
BOOL file_dialog(char *text, char *caption, BOOL load);
void info_dialog(fent_t* fs);
void version_dialog(void);
void wait_dialog(char *caption, char *msg, void(*fp)(void));

void update_menu(void);
void load_profile(void);
void save_profile(void);
int get_applink(FS fs);
void init_trace(void);
void reboot(void);
void char_map(void);

void main()
{
	WORD key;
	int redraw;

	load_profile();
	init_trace();
	init_remote_mode(sys_get_remote());

	folder.fsid = FS_FLASH;
InitDisplay:
	init_display(TRUE);
	redraw = TRUE;

	for(;;) {
		int command;
		fent_t *fs;
		if(redraw) {
			init_folder(&folder, redraw);
			draw_desktop(NULL);
			redraw = FALSE;
		}
		draw_status(&folder);
		while((key = do_folder(&folder)) == 0) {
			if(remote.mode) {
				if((command = do_remote(&folder)) != 0) {
					if(command == ID_FILE_EXEC) goto Exec;
					goto DoCommand;
				}
			}
		}
		if(key == KEY_A) {
Exec:		fs = get_entry(folder.select);
			if(fs->mode & FMODE_X) {
				exec_file(NULL);
				goto ExecReturn;
			} else if((fs->mode & ~(FMODE_R|FMODE_W)) == 0) {
				exec_file(applink[get_applink(fs)].app);
ExecReturn:		/* init_display(TRUE); */
				key_hit_check();
				/* redraw = TRUE; */
			} else
				info_dialog(fs);
		}
		else if(key == KEY_B) {
			menu_bar.menu_sel = MENU_FILE;
			update_menu();
			command = do_menu(&menu_bar);
			if(command == -1) continue;
DoCommand:
			fs = get_entry(folder.select);
			msgbuff[lstrncpy(msgbuff, fs->name, MAXFNAME)] = '\0';
			switch(command) {
				case ID_SYS_VERSION:
					version_dialog();
					break;
				case ID_SYS_REBOOT:
					text_screen_init();
					text_put_string(11, 8, "REBOOT");
					sys_wait(75);
					reboot();
					break;
				case ID_FILE_LOAD:
					redraw = file_dialog("t@CM܂", "Load", TRUE);
					done_remote(redraw);
					break;
				case ID_FILE_SAVE:
					file_dialog("t@C𑗐M܂", "Save", FALSE);
					break;
				case ID_FILE_REMOTE:
					init_remote_mode(!remote.mode);
					break;
				case ID_FILE_DELETE:
					strcat(msgbuff, "\n폜Ă낵łH");
					if(message_box(msgbuff, "Delete", MB_ICONQUESTION | MB_YES | MB_NO | MB_DEFBUTTON2) == IDYES) {
						delete_file();
						redraw = SELECT_CUR;
					}
					break;
				case ID_FILE_INFO:
					info_dialog(fs);
					break;

				case ID_GROUP_FLASH_SRAM:
					folder.fsid ^= 1;
					redraw = TRUE;
					break;
				case ID_GROUP_FLASH:
					folder.fsid = FS_FLASH;
					redraw = TRUE;
					break;
				case ID_GROUP_SRAM:
					folder.fsid = FS_SRAM;
					redraw = TRUE;
					break;
				case ID_GROUP_SYSTEM:
					folder.flags ^= FOLDER_SYS;
					goto SaveProf;
				case ID_VIEW_ICON_LIST:
					folder.flags ^= FOLDER_LIST;
					goto SaveProf;
				case ID_VIEW_ICON:
					folder.flags &= ~FOLDER_LIST;
					goto SaveProf;
				case ID_VIEW_LIST:
					folder.flags |= FOLDER_LIST;
SaveProf:			save_profile();
					redraw = TRUE;
					break;
				case ID_VIEW_WALLPAPER:
					options.wp ^= 1;
					save_profile();
					init_display(FALSE);
					break;
				case ID_TOOL_TRACE:
					options.trace ^= 1;
					save_profile();
					init_trace();
					break;
		/*		case ID_TOOL_DUMP:
					text_screen_init();
					memory_dump();
					goto InitDisplay;
		*/		case ID_TOOL_CHARMAP:
					text_screen_init();
					char_map();
					goto InitDisplay;
				case ID_TOOL_DEFLAG:
					wait_dialog("Deflag", "\x016\x016", deflag);
					redraw = TRUE;
					break;
				case ID_TOOL_ERASE:
					if(message_box("Ă낵łH", "Erase All", MB_ICONEXCLAMATION | MB_YES | MB_NO | MB_DEFBUTTON2) == IDYES) {
						wait_dialog("Erase All", "\x016\x016", new_fs);
						redraw = TRUE;
					}
					break;
			};
		} else {
			int i;
			for_to(i, MAX_SHORTKEY) {
				if(shortkey[i].key == key) {
					command = shortkey[i].command;
					goto DoCommand;
				}
			}
		}
	}
}

void init_display(BOOL cls)
{
	display_control((options.wp ? DCM_SCR1 : 0) | DCM_SCR2 | DCM_SPR);

	palette_set_color(PAL_TILE, 0x3210);
	palette_set_color(PAL_DESKTOP,	0x7400);
	palette_set_color(PAL_WINDOW,	0x7402);
	palette_set_color(PAL_FRAME,	0x5200);
	palette_set_color(PAL_BTNFRAME, 0x5202);

	if(cls) {
		text_set_screen(SCREEN2);
		text_set_mode(TEXT_MODE_ANK_SJIS);
		text_screen_init();
		draw_wallpaper();
		reserve_sprite_font();
	}
}

void update_menu()
{
	BOOL enable = folder.files ? TRUE : FALSE;
	menu_set_check(&menu_bar, ID_FILE_REMOTE, remote.mode);
	menu_set_enable(&menu_bar, ID_FILE_SAVE, enable);
	menu_set_enable(&menu_bar, ID_FILE_DELETE, enable);
	menu_set_enable(&menu_bar, ID_FILE_INFO, enable);
	menu_set_enable(&menu_bar, ID_FILE_INFO, enable);
	menu_set_radio(&menu_bar, ID_GROUP_FLASH, 2, folder.fsid == FS_SRAM);
	menu_set_check(&menu_bar, ID_GROUP_SYSTEM, folder.flags & FOLDER_SYS);
	menu_set_radio(&menu_bar, ID_VIEW_ICON, 2, folder.flags & FOLDER_LIST);
	menu_set_check(&menu_bar, ID_VIEW_WALLPAPER, options.wp);
	init_trace();
}

static Rect rect_desktop = { 0, 0, LCD_CHAR_CX, LCD_CHAR_CY - 2 };

void draw_desktop(Rect *r_clip)
{
	set_palette_rect(r_clip ? r_clip : &rect_desktop, PAL_DESKTOP);
	draw_folder(&folder, r_clip);
}

#define FONT_TILE 4
#define FONT_TILE_COUNT 4

void draw_wallpaper()
{
	int x, y;
	static WORD char_tile[4] = {
		FONT_TILE | PAL_TILE << PALSFT,
		FONT_TILE+1 | PAL_TILE << PALSFT,
		FONT_TILE+2 | PAL_TILE << PALSFT,
		FONT_TILE+3 | PAL_TILE << PALSFT,
	};

	font_set_far_colordata(FONT_TILE, FONT_TILE_COUNT, get_bmpres(BMP_TILE));

	for(y=0; y < LCD_CHAR_CY; y+=2)
		for(x=0; x < LCD_CHAR_CX; x+=2)
			screen_set_char(SCREEN1, x, y, 2, 2, char_tile);
}

/*
 * file load/save dialog
 */

enum { FDLG_ICON, FDLG_TEXT1, FDLG_TEXT2, FDLG_PROGBAR, FDLG_BLOCK_C, FDLG_RETRY, FDLG_COUNT };

static Control ctr_filedlg[FDLG_COUNT] = {
	{ CTR_ICON, 0, ICON_COMM,  0, 0, 1, 0 },
	{ CTR_TEXT, 0, NULL, 0, 0, 4, 0 },
	{ CTR_TEXT, 0, NULL, 0, 0, 4, 1 },
	{ CTR_PROGRESSBAR, 0, NULL, 0, 0, 1, 3, 10, 1 },
	{ CTR_VALUE, 0, NULL, 0, 0, 12, 3, 3, 0 },
	{ CTR_TEXT, 0, NULL, 0, 0, 2, 4, 0, 0 },
};
	
static Dialog dlg_file = { NULL, ctr_filedlg, MB_CANCEL, FDLG_COUNT, 0, NULL, 0, 0, 16, 9 };

int xmodem_callback(xmodeminfo *xminfo, fent_t *fs)
{
	Control *ctr = &ctr_filedlg[FDLG_TEXT2];
	switch(xminfo->state) {
	case XM_NEGO:
		ctr->data.p = "ҋ@\x016\x016";
		ctr->flags = CTF_REDRAW;
		break;
	case XM_BLOCK:
		if(fs) {
			if(xminfo->block_c == 1) {
				ctr->data.p = fs->name;
				ctr->flags = CTF_REDRAW;
				folder.fname[lstrncpy(folder.fname, fs->name, MAXFNAME)] = '\0';
			}
			if(xminfo->block_c > 1) {
				ctr = &ctr_filedlg[FDLG_PROGBAR];
				ctr->range = fs->count;
				ctr->value = xminfo->block_c;
				ctr->flags =CTF_REDRAW;
				ctr = &ctr_filedlg[FDLG_BLOCK_C];
				ctr->data.n = xminfo->block_c - 1;
				ctr->flags =CTF_REDRAW;
			}
		}
		break;
	case XM_BLOCK_RETRY:
		sprintf(msgbuff, "Retry %d", xminfo->retry_c);
		ctr = &ctr_filedlg[FDLG_RETRY];
		ctr->data.p = msgbuff;
		ctr->flags =CTF_REDRAW;
		break;
	}
	redraw_dialog(&dlg_file, FALSE);
}

typedef struct {
	int errcode;
	char *errmsg;
} ErrTable;

ErrTable errtable[] = {
	ERR_SIO_TIMEOUT,	"TIMEOUT ERROR",
	ERR_SIO_OVERRUN,	"OVER RUN ERROR",
	ERR_XM_BLOCK_LOST,	"BLOCK LOST",
	ERR_XM_TOO_LARGE,	"DATA TOO LARGE",
	E_ILIB_NOT_FBF,		"t@C`Ⴂ܂",
	E_FS_NO_SPACE_LEFT,	"󂫃GA܂",
	0, NULL,
};

char *get_error_message(int errcode)
{
	ErrTable *err = errtable;
	
	while(err->errcode) {
		if(errcode == err->errcode)
			return err->errmsg;
		err++;
	}
	sprintf(msgbuff, "Error (%x)", errcode);
	return msgbuff;
}

BOOL file_dialog(char *text, char *caption, BOOL load)
{
	result_t result;
	dlg_file.caption = caption;
	ctr_filedlg[FDLG_TEXT1].data.p = text;
	ctr_filedlg[FDLG_TEXT2].flags =	ctr_filedlg[FDLG_PROGBAR].flags 
	= ctr_filedlg[FDLG_BLOCK_C].flags =	ctr_filedlg[FDLG_RETRY].flags = CTF_HIDE;
	if(remote.mode) remote_disable();
	open_dialog(&dlg_file);
	comm_set_cancel_key(KEY_B);
	if(load)
		result = receive_file(xmodem_callback);
	else
		result = send_file(xmodem_callback);
	comm_close();
	close_dialog(&dlg_file);
	if(remote.mode) remote_enable();
	if((int)result < 0) {
		if(result == ERR_SIO_CANCEL)
			key_hit_check();
		else
			message_box( get_error_message(result), caption, MB_ICONERROR | MB_OK);
		return FALSE;
	}
	return load ? SELECT_NAME : FALSE;
}

/*
 * file info dialog
 */

enum {
	IDLG_NAME_L, IDLG_NAME, /* Name: Calendar */
	IDLG_INFO_L, IDLG_INFO, /* Info: J_ */
	IDLG_LINE1,
	IDLG_ICON,
	IDLG_SIZE_L, IDLG_SIZE, /* Size: 123,456  */
	IDLG_LOC_L,	 IDLG_LOC,	/*	Loc: #0:0000 */
	IDLG_ATTR_L, IDLG_ATTR, /* Attr: xr----	  */
	IDLG_DATE_L, IDLG_DATE, /* Date: 2000/04/12 */
	IDLG_TIME_L, IDLG_TIME, /* Time: 12:34:56 */
	IDLG_INDEX,
	IDLG_COUNT
};

void *draw_info(int x, int y, int ctri, fent_t *fs);

static Control ctr_infodlg[IDLG_COUNT] = {
	{ CTR_TEXT, 0, "Name:", 0, 0, 1, 0 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 6, 0 },
	{ CTR_TEXT, 0, "Info:", 0, 0, 1, 1 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 6, 1, 0, 2 },
	{ CTR_HLINE, 0, 0, 0, 0, 0, 3 },
	{ CTR_ICON, CTF_OWNER_DRAW, draw_info,  0, 0, 1, 4 },
	{ CTR_TEXT, 0, "Size:", 0, 0, 6, 4 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 11, 4 },
	{ CTR_TEXT, 0, "Loc:", 0, 0, 7, 5 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 11, 5 },
	{ CTR_TEXT, 0, "Attr:", 0, 0, 6, 6 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 11, 6 },
	{ CTR_TEXT, 0, "Date:", 0, 0, 6, 7 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 11, 7 },
	{ CTR_TEXT, 0, "Time:", 0, 0, 6, 8 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 11, 8 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_info, 0, 0, 16, 10 },
};

static Dialog dlg_info = { "File Info", ctr_infodlg, MB_OK, IDLG_COUNT, 0, NULL, 0, 0, 22, 14 };
static int file_index;

void *draw_info(int x, int y, int ctri, fent_t *fs)
{
	switch(ctri) {
	case IDLG_NAME:
		msgbuff[lstrncpy(msgbuff, fs->name, MAXFNAME)] = '\0';
		break;
	case IDLG_INFO:
		msgbuff[lstrncpy(msgbuff, fs->info, MAXFINFO)] = '\0';
		break;
	case IDLG_ICON:
		draw_icon(x, y, file_index);
		return NULL;
	case IDLG_SIZE:
		sprintf(msgbuff, "%,lu", fs->len);
		break;
	case IDLG_LOC:
		sprintf(msgbuff, "#%d:%04x", (fs->loc.w.seg)&7, fs->loc.w.off);
		break;
	case IDLG_ATTR:
		get_fmode_string(msgbuff, fs->mode);
		break;
	case IDLG_DATE:
		get_mtime_string(msgbuff, fs->mtime, TRUE);
		break;
	case IDLG_TIME:
		get_mtime_string(msgbuff, fs->mtime, FALSE);
		break;
	case IDLG_INDEX:
		sprintf(msgbuff, "%2d/%d", file_index + 1, folder.files);
		break;
	}
	return msgbuff;
}

void info_dialog(fent_t* fs)
{
	file_index = folder.select;
	dlg_info.param = fs;
	open_dialog(&dlg_info);
	for(;;) {
		switch(key_wait()) {
		case KEY_A:
		case KEY_B:
			goto Close;
		case KEY_RIGHT1:
			if(folder.files > 1) {
				if(++file_index >= folder.files) file_index=0;
				goto Another;
			}
			break;
		case KEY_LEFT1:
			if(folder.files > 1) {
				if(--file_index < 0) file_index = folder.files - 1;
Another:		dlg_info.param = get_entry(file_index);
				redraw_dialog(&dlg_info, TRUE);
			}
			break;
		}
	}
Close:
	close_dialog(&dlg_info);
}

/*
 * version dialog
 */

enum {
	VDLG_FREYA, /* Freya: 1.0 */
	VDLG_BIOS,	/*	BIOS: 1.0 */
	VDLG_OS,	/*	  OS: 1.0 */
	VDLG_SHELL, /*	 Ged: 1.0 */
	VDLG_LINE1,
	VDLG_OWNER_L, VDLG_OWNER, /*  owner: c.mos */
	VDLG_COUNT
};

void *draw_version(int x, int y, int ctri, fent_t *fs);

static Control ctr_versiondlg[VDLG_COUNT] = {
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_version, 0, 0, 1, 0 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_version, 0, 0, 1, 1 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_version, 0, 0, 1, 2 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_version, 0, 0, 1, 3 },
	{ CTR_HLINE, 0, 0, 0, 0, 0, 4 },
	{ CTR_TEXT, 0, "owner:", 0, 0, 1, 5 },
	{ CTR_TEXT, CTF_OWNER_DRAW, draw_version, 0, 0, 7, 5, 0, 2 },
};

static Dialog dlg_version = { "Version", ctr_versiondlg, MB_OK, VDLG_COUNT, 0, NULL, 0, 0, 21, 12 };

extern char far *_description;

#define MAX_OWNER_NAME 16

void get_version_string(char *buff, WORD ver, char *title)
{
	sprintf(buff, "%s%d.%d.%d", title, ver>>12, (ver>>8) & 0x0F, ver & 0x0F);
}

void *draw_version(int x, int y, int ctri, fent_t *fs)
{
	WORD ver;
	switch(ctri) {
	case VDLG_FREYA:
		sprintf(msgbuff, "Freya:1.0");
		break;
	case VDLG_BIOS:
		get_version_string(msgbuff, sys_get_version(), " BIOS:");
		break;
	case VDLG_OS:
		get_version_string(msgbuff, os_get_version(),  "   OS:");
		break;
	case VDLG_SHELL:
		sprintf(msgbuff, "Shell:%ls", _description);
		break;
	case VDLG_OWNER:
		sys_get_ownerinfo(MAX_OWNER_NAME, msgbuff);
		*(msgbuff + MAX_OWNER_NAME) = '\0';
	}
	return msgbuff;
}

void version_dialog()
{
	open_dialog(&dlg_version);
	key_wait();
	close_dialog(&dlg_version);
}

enum {
	WDLG_ICON,
	WDLG_TEXT,
	WDLG_COUNT
};

static Control ctr_waitdlg[WDLG_COUNT] = {
	{ CTR_ICON, 0, ICON_EXCLAMATION,  0, 0, 1, 0 },
	{ CTR_TEXT, 0, NULL, 0, 0, 4, 0 },
};
static Dialog dlg_wait = { NULL, ctr_waitdlg, 0, WDLG_COUNT, 0, NULL, 0, 0, 12, 5 };

void wait_dialog(char *caption, char *msg, void(*fp)(void))
{
	dlg_wait.caption = caption;
	ctr_waitdlg[WDLG_TEXT].data.p = msg;
	open_dialog(&dlg_wait);
	fp();
	close_dialog(&dlg_wait);
}

/*
 *	profile read/write
 */

void load_profile()
{
	open_profile(TRUE, "ged.ini", 0);
	if(read_profile_section("Desktop")) {
		options.wp = read_profile_int("WP", 1);
		options.trace = read_profile_int("Trace", 0);
		folder.flags = read_profile_int("Folder", 0);
		read_profile_intarray("Colors", colors, CLR_COUNT);
	}
	icon_ref_count = 0;
	if(read_profile_section("Icons")) {
		for(;;) {
			IconRef *ref = &icon_ref[icon_ref_count];
			if(!read_profile_next_key(ref->name)) break;
			ref->icon = read_profile_int(ref->name, ICON_SWAN);
			icon_ref_count++;
		}
	}
	if(read_profile_section("Link")) {
		for(;;) {
			AppLink *al = &applink[applink_count];
			if(!read_profile_next_key(al->name)) break;
			read_profile_string(al->name, NULL, al->app);
			applink_count++;
		}
	}
	if(read_profile_section("Key")) {
		int i;
		for_to(i, MAX_SHORTKEY) {
			shortkey[i].command = read_profile_int(shortkey[i].name, 0);
		}
	}
	close_profile();
}

void save_profile()
{
	int i;
	open_profile(FALSE, "ged.ini", 0);
	write_profile_section("Desktop");
	write_profile_int("WP", options.wp);
	write_profile_int("Trace", options.trace);
	write_profile_int("Folder", folder.flags);
	write_profile_intarray("Colors", colors, CLR_COUNT);
	if(icon_ref_count) {
		write_profile_section("Icons");
		for_to(i, icon_ref_count)
			write_profile_int(icon_ref[i].name, icon_ref[i].icon);
	}
	if(applink_count) {
		write_profile_section("Link");
		for_to(i, applink_count) {
			write_profile_string(applink[i].name, applink[i].app);
		}
	}
	write_profile_section("Key");
	for_to(i, MAX_SHORTKEY) {
		int command = shortkey[i].command;
		if(command)
			write_profile_int(shortkey[i].name, command);
	}
	
	close_profile();
}

int get_applink(FS fs)
{
	int n;
	n = find_filetype(folder.fsid, fs, applink[0].name, sizeof(AppLink), applink_count);
	if(n == -1) n = 0;
	return n;
}

/*
 * remote debug
 */

static DebugIL debugIL;

void init_trace()
{
	BOOL il = (open_debug_il(&debugIL) == E_FS_SUCCESS);
	menu_set_enable(&menu_bar, ID_TOOL_TRACE, il);
	if(il) {
		set_trace_mode(options.trace);
		menu_set_check(&menu_bar, ID_TOOL_TRACE, options.trace);
	}
}
