/*
 *	IL interface manager definitions
 *	issued: 2000/4/5
 *	author: c.mos@zob.ne.jp
 */

#ifndef _ILIB_H_
#define _ILIB_H_

#include <sys/oswork.h>
#include <sys/process.h>

#ifndef NO_IL
#undef _pc
extern ProcContext* _pc;
#endif

typedef enum { FS_FLASH, FS_SRAM, FS_COUNT } FSID;

#define E_ILIB_NOT_FBF 0x9001

void set_current_fs(FSID fsid);
void set_mask(fmode_t _mask);
int	 get_file_count(void);
BOOL get_entry_tmp(int index, fent_t __ss *fentp);
fent_t *get_entry(int index);
int select_file(char far *name);
void get_fullpath(char far *buffer);
void exec_file(char *app);
ulong get_free_space(void);
void far *get_location(floc_t loc);
void delete_file(void);
void new_fs(void);
void deflag(void);
size_t read_file(FSID fsid, char far *name, void *buffer, size_t size);
size_t write_file(FSID fsid, char far *name, void *buffer, size_t size);
size_t read_resource_header(FSID fsid, FS fs, res_t __ss *res);

int receive_file(int (*callback)(xmodeminfo *, fent_t *));
int send_file(int (*callback)(xmodeminfo *, fent_t *));

unsigned os_get_version(void);

#endif _ILIB_H_
