/*
 *	Menu manager definitions
 *	issued: 2000/4/2
 *	author: c.mos@zob.ne.jp
 */

#ifndef _MENU_H_
#define _MENU_H_

#include "gui.h"

#define MF_CHECKED	 1
#define MF_GRAYED	 2
#define MF_RADIOCHECK 4

typedef struct {
	char *label;	/* if NULL, separator */
	char *help;
	BYTE  flags;
	char  id;
} MenuItem;

typedef struct {
	MenuItem *items;
	int item_count;
	int item_sel;
	Rect wnd;
} Menu;

typedef struct {
	MenuItem *items;
	int menu_count;
	int menu_sel;
	Menu *menus;
} MenuBar;

void draw_menubar(MenuBar *bar);
void erase_menubar(void);
void draw_menu(Menu *menu);
void erase_menu(Menu *menu);
void draw_menuitem(Menu *menu, int item);
int do_menu(MenuBar *bar);
void menu_set_enable(MenuBar* bar, int id, BOOL enable);
void menu_set_check(MenuBar* bar, int id, BOOL check);
void menu_set_radio(MenuBar* bar, int id, int count, int select);

#endif _MENU_H_
